function [A] = basicilu(A)
% BASICILU fattorizzazione LU incompleta.
%  Y=BASICILU(A): U e` memorizzata nella parte triangolare superiore di Y
%  e L e` memorizzata nella parte triangolare inferiore stretta di Y.
%  I fattori L e U hanno la stessa struttura di sparsita` della matrice A.
[n,m]=size(A);
if n ~= m, error('Solo matrici quadrate'); end
for k=1:n-1
    for i=k+1:n,
        if A(i,k) ~= 0
            if A(k,k) == 0, error('Elemento pivotale nullo'); end
            A(i,k)=A(i,k)/A(k,k);
            for j=k+1:n
                if A(i,j) ~= 0, A(i,j)=A(i,j)-A(i,k)*A(k,j); end
            end
        end
    end
end
return
