function [zero,iter,xvect,xdif,fx]=bisect(fun,a,b,tol,nmax)
% BISECT metodo di bisezione.
% [ZERO,ITER,XVECT,XDIF,FX]=BISECT(FUN,A,B,TOL,NMAX) cerca lo zero di una
% funzione continua FUN nell'intervallo [A,B] usando il metodo di bisezione.
% TOL e NMAX specificano la tolleranza ed il massimo numero di iterazioni.
% FUN riceve in ingresso lo scalare x e restituisce un valore scalare reale.
% ZERO e` l'approssimazione della radice, ITER e` il numero di iterate svolte.
% XVECT e` il vettore delle iterate, XDIF il vettore delle differenze tra iterate
% successive, FX il vettore dei residui.
err=tol+1; iter=0;
xvect=[]; fx=[]; xdif=[];
while iter < nmax && err > tol
    iter=iter+1;
    c=(a+b)/2; fc=fun(c); xvect=[xvect;c];
    fx=[fx;fc]; fa=fun(a);
    if fc*fa>0
        a=c;
    else
        b=c;
    end
    err=0.5*abs(b-a); xdif=[xdif;err];
end
zero=xvect(end);
return
