function [zero,iter,xvect,xdif,fx]=chord(fun,a,b,x0,tol,nmax)
% CHORD metodo delle corde
% [ZERO,ITER,XVECT,XDIF,FX]=CHORD(FUN,A,B,X0,TOL,NMAX) cerca lo zero di
% una funzione continua FUN nell'intervallo [A,B] usando il metodo delle
% corde partendo da X0. TOL e NMAX specificano la tolleranza ed il massimo numero
% di iterazioni. FUN riceve in ingresso lo scalare x e restituisce un valore scalare reale.
% ZERO e` l'approssimazione della radice, ITER e` il numero di iterate svolte.
% XVECT e` il vettore delle iterate, XDIF il vettore delle differenze tra iterate
% successive, FX il vettore dei residui.
fa=fun(a); fb=fun(b);
r=(fb-fa)/(b-a);
err=tol+1; iter=0; xvect=x0; fxx=fun(x0);
xdif=[]; fx=[fxx];
while iter < nmax && err > tol
    x=x0-fxx/r; fxx=fun(x);
    err=abs(x-x0);
    xdif=[xdif; err];
    xvect=[xvect;x];
    fx=[fx;fxx];
    iter=iter+1;
    x0=x;
end
zero=xvect(end);
return
