function [k1]=condest2(A,L,U,theta)
% CONDEST2 stima del numero di condizionamento in norma 1.
%  K1=CONDEST2(A,L,U,THETA) restituisce una stima del numero di condizionamento
%  di una matrice A. L e U sono i fattori della fattorizzazione LU di A.
%  THETA contiene numeri casuali.
[n,m]=size(A);
if n ~= m, error('Solo matrici quadrate'); end
p = zeros(1,n);
for k=1:n
    zplus=(theta(k)-p(k))/U(k,k);   zminu=(-theta(k)-p(k))/U(k,k);
    splus=abs(theta(k)-p(k));       sminu=abs(-theta(k)-p(k));
    for i=k+1:n
        splus=splus+abs(p(i)+U(k,i)*zplus);
        sminu=sminu+abs(p(i)+U(k,i)*zminu);
    end
    if splus \ensuremath{>}= sminu,  z(k)=zplus;   else,  z(k)=zminu;  end
    i=[k+1:n];  p(i)=p(i)+U(k,i)*z(k);
end
z = z';
x = backwardcol(L',z);
w = forwardcol(L,x);
y = backwardcol(U,w);
k1=norm(A,1)*norm(y,1)/norm(x,1);
return
