function [zero,iter,xvect,xdif,fx]=fixpoint(fun,phi,x0,tol,nmax)
% FIXPOINT iterazione di punto fisso.
% [ZERO,ITER,XVECT,XDIF,FX]=FIXPOINT(FUN,PHI,X0,TOL,NMAX) cerca lo zero di
% una funzione continua FUN usando il metodo di punto fisso X=PHI(X), partendo
% dal dato iniziale X0. FUN riceve in ingresso lo scalare x e restituisce un valore
% scalare reale. TOL specifica la tolleranza del metodo. ZERO e` l'approssimazione della
% radice. ITER e` il numero di iterate svolte, XVECT e` il vettore delle iterate,
% XDIF il vettore delle differenze tra iterate successive, FX il vettore dei residui.
err=tol+1; iter=0;
fx0=fun(x0); xdif=[]; xvect=x0; fx=fx0;
while iter < nmax && err > tol
    x=phi(x0);
    err=abs(x-x0); xdif=[xdif; err]; xvect=[xvect;x];
    x0=x; fx0=fun(x0); fx=[fx;fx0];
    iter=iter+1;
end
zero=xvect(end);
return
