function [alpha,res,iter]=fixposys(F,Phi,x0,tol,nmax)
% FIXPOSYS metodo di punto fisso per sistemi non lineari.
%  [ALPHA, RES, ITER] = FIXPOSYS(F, PHI, X0, TOL, NMAX) risolve il
%  sistema non lineare F(X)=0 con il metodo di punto fisso. F e PHI sono
%  function handle associati alle funzioni F e PHI rispettivamente. X0
%  specifica il vettore iniziale, TOL la tolleranza del metodo, NMAX il
%  numero massimo delle iterazioni. ITER e` l'iterazione alla quale il punto
%  fisso ALPHA e` calcolato. RES e` il residuo del sistema calcolato in ALPHA.
alpha=x0'; r=F(x0); res0=norm(r,inf);
res=res0; iter = 0;
while iter <= nmax && res0 >= tol
   x= Phi(x0);
   alpha=[alpha;x'];
   r=F(x); res0=norm(r,inf);
   res=[res;res0];
   iter = iter + 1; x0=x;
end
return
