function [x]=forwardcol(L,b)
% FORWARDCOL sostituzioni in avanti: versione orientata per colonne.
%  X=FORWARDCOL(L,B) risolve il sistema triangolare inferiore L*X=B con il
%  metodo delle sostituzioni in avanti nella versione orientata per colonne.
[n,m]=size(L); x=[];
if n ~= m, warning('Solo sistemi quadrati'); return; end
if min(abs(diag(L))) == 0, error('Sistema singolare'); end
x=b;
for j=1:n-1
    x(j) = x(j)/L(j,j); x(j+1:n)=x(j+1:n)-x(j)*L(j+1:n,j);
end
x(n) = x(n)/L(n,n);
return
