function [x]=forwardrow(L,b)
% FORWARDROW sostituzioni in avanti: versione orientata per righe.
%  X=FORWARDROW(L,B) risolve il sistema triangolare inferiore L*X=B con il
%  metodo delle sostituzioni in avanti nella versione orientata per righe.
[n,m]=size(L); x=[];
if n ~= m, warning('Solo sistemi quadrati'); return; end
if min(abs(diag(L))) == 0, error('Sistema singolare'); end
x=zeros(n,1);
x(1) = b(1)/L(1,1);
for i = 2:n
    x(i) = (b(i)-L(i,1:i-1)*x(1:i-1))/L(i,i);
end
return
