function [c,s]=givcos(xi, xk)
% GIVCOS calcola seni e coseni per le rotazioni di Givens.
% [C,S]=GIVCOS(XI, XK) Date le due componenti XI e XK di un vettore,
% vengono calcolati C=COS(THETA) e S=SIN(THETA) per generare una rotazione
% di Givens che annulli una delle due componenti.
if xk==0
    c=1; s=0;
else
    if abs(xk)>abs(xi)
        t=-xi/xk; s=1/sqrt(1+t^2); c=s*t;
    else
        t=-xk/xi; c=1/sqrt(1+t^2); s=c*t;
   end
end
return
