function [A,lev]=ilup(A,p)
% ILUP fattorizzazione LU(p) incompleta.
%  [Y,LEV]=ILUP(A,P): U e` memorizzata nella parte triangolare superiore di Y
%  e L e` memorizzata nella parte triangolare inferiore stretta di Y.
%  I fattori L e U hanno livello di fill-in pari a P, mentre LEV contiene
%  il livello di fill-in di ogni elemento al termine della fattorizzazione.
[n,m]=size(A);
if n ~= m, error('Solo matrici quadrate'); end
lev=Inf*ones(n,n);
i=(A~=0);
lev(i)=0,
for i=2:n
    for k=1:i-1
        if lev(i,k) <= p
            if A(k,k)==0, error('Elemento pivotale nullo'); end
            A(i,k)=A(i,k)/A(k,k);
            for j=k+1:n
                A(i,j)=A(i,j)-A(i,k)*A(k,j);
                if A(i,j) ~= 0
                    lev(i,j)=min(lev(i,j),lev(i,k)+lev(k,j)+1);
                end
            end
        end
    end
    for j=1:n, if lev(i,j) > p, A(i,j) = 0; end, end
end
return
