function [x,iter]=jor(A,b,x0,nmax,tol,omega)
% JOR metodo JOR
%  [X,ITER]=JOR(A,B,X0,NMAX,TOL,OMEGA) risolve il sistema
%  A*X=B con il metodo JOR. TOL specifica la tolleranza del metodo,
%  NMAX il numero massimo di iterazioni, mentre X0 e` il vettore iniziale.
%  OMEGA e` il parametro di rilassamento, ITER indica l'iterazione alla
%  quale e` calcolata la soluzione X.
[n,m]=size(A);
if n ~= m, error('Solo sistemi quadrati'); end
iter=0;
r = b-A*x0; r0=norm(r); err=norm(r); x=x0;
while err > tol && iter < nmax
    iter = iter + 1;
    for i=1:n
        s = 0;
        for j = 1:i-1, s=s+A(i,j)*x(j);   end
        for j = i+1:n, s=s+A(i,j)*x(j);   end
        xnew(i,1)=omega*(b(i)-s)/A(i,i)+(1-omega)*x(i);
    end
    x=xnew;  r=b-A*x;  err=norm(r)/r0;
end
return
