function [A]=lukji(A)
% LUKJI fattorizzazione LU di una matrice A nella versione kji
%   Y=LUKJI(A): U e` memorizzata nella parte triangolare superiore di Y
%   e L nella parte triangolare inferiore stretta di Y.
[n,m]=size(A);
if n ~= m, error('Solo sistemi quadrati'); end
for k=1:n-1
    if A(k,k)==0; error('Elemento pivotale nullo'); end
    A(k+1:n,k)=A(k+1:n,k)/A(k,k);
    for j=k+1:n
        i=k+1:n; A(i,j)=A(i,j)-A(i,k)*A(k,j);
    end
end
return
