function [t,u]=multistep(a,b,tf,t0,u0,h,fun,dfun,tol,itmax)
% MULTISTEP metodo multistep.
% [T,U]=MULTISTEP(A,B,TF,T0,U0,H,FUN,DFUN,TOL,ITMAX) risolve il problema
% di Cauchy Y'=FUN(T,Y), per T in (T0,TF), utilizzando il metodo multistep
% avente coefficienti A e B. H specifica il time step. TOL specifica la
% tolleranza dell'iterazione di punto fisso quando il metodo multistep e`
% di tipo implicito.
f = fun(t0,u0); p = length(a) - 1; u = u0;
nt = fix((tf - t0 (1) )/h);
for k = 1:nt
    lu=length(u);
    G=a'*u(lu:-1:lu-p)+ h*b(2:p+2)'*f(lu:-1:lu-p);
    t0=[t0; t0(lu)+h];
    if b(1)==0 % caso esplicito
        unew=G;fn=fun(t0(end),unew);
    else % caso implicito, risolvo con Newton
    un=u(lu); unew=un;
    t=t0(lu+1); err=tol+1; it=0;
    while err>tol && it<=itmax
        den=1-h*b(1)*dfun(t,unew);
        fn=fun(t,unew);
        if den == 0
            it=itmax+1;
        else
            it=it+1;
            unew1=unew-(unew-G-h*b(1)* fn)/den;
            err=abs(unew1-unew);
            unew=unew1;
        end
    end
    end
    u=[u; unew]; f=[f; fn];
end
t=t0;
return
