function [Q,R,c,s]= qrgivens(H)
% QRGIVENS fattorizzazione QR
% [Q,R,C,S]= QRGIVENS(H) fattorizzazione QR di una matrice in forma
% di Hessenberg superiore con rotazioni di Givens. I vettori C e S
% contengono rispettivamente seni e coseni delle rotazioni.
[m,n]=size(H);
for k=1:n-1
    [c(k),s(k)]=givcos(H(k,k),H(k+1,k));
    H=garow(H,c(k),s(k),k,k+1,k,n);
end
R=H; Q=prodgiv(c,s,n);
return

function Q=prodgiv(c,s,n)
n1=n-1; n2=n-2;
Q=eye(n); Q(n1,n1)=c(n1); Q(n,n)=c(n1);
Q(n1,n)=s(n1); Q(n,n1)=-s(n1);
for k=n2:-1:1,
   k1=k+1; Q(k,k)=c(k); Q(k1,k)=-s(k);
   q=Q(k1,k1:n); Q(k,k1:n)=s(k)*q;
   Q(k1,k1:n)=c(k)*q;
end
return
