function int = simpsonc(a,b,m,fun)
% SIMPSONC formula composita di Simpson.
% INT=SIMPSONC(A,B,M,FUN) calcola un'approssimazione dell'integrale della
% funzione FUN su (A,B) con il metodo di Simpson su una griglia uniforme
% di M intervalli. FUN riceve in ingresso un vettore reale x e restituisce un
% vettore della stessa dimensione.
h=(b-a)/m;
x=[a:h/2:b];
y=fun(x);
if size(y)==1
dim= length(x);
   y=ones(dim,1).*y;
end
int=(h/6)*(y(1)+2*sum(y(3:2:2*m-1))+4*sum(y(2:2:2*m))+y(2*m+1));
return
