function int = trapezc(a,b,m,fun)
% TRAPEZC formula composita del trapezio.
% INT=TRAPEZC(A,B,M,FUN) calcola un'approssimazione dell'integrale della
% funzione FUN su (A,B) con il metodo del trapezio su una griglia uniforme
% di M intervalli. FUN deve essere definita su vettori
h=(b-a)/m;
x=[a:h:b];
y=fun(x);
if size(y)==1
    dim=length(x);
    y=y.*ones(dim,1);
end
int=h*(0.5*y(1)+sum(y(2:m))+0.5*y(m+1));
return
