function [x,w]=zpherm(n)
% ZPHERM formula di Hermite-Gauss.
% [X,W]=ZPHERM(N) calcola nodi e pesi della formula di Hermite-Gauss a N+1 nodi.
if n<1, error('n deve essere >=1 '); end
np=n+1;
[a,b]=coefherm(np);
JacM=diag(a)+diag(sqrt(b(2:np)),1)+diag(sqrt(b(2:np)),-1);
[w,x]=eig(JacM); x=diag(x); scal=sqrt(pi); w=w(1,:)'.^2*scal;
[x,ind]=sort(x); w=w(ind);
return
